<template>
  <q-page padding>
    <q-toolbar class="bg-blue-grey text-white shadow-2 rounded-borders">
      Sistema de Novedades
      <q-space />
      <div class="q-gutter-xs">
        <q-btn
          flat
          dense
          icon="control_point"
          label="Nuevo"
          to="/administrador/novedades/alta"
        />
      </div>
    </q-toolbar>

    <q-card class="q-mt-sm">
      <q-table
        :dense="true"
        :rows="dataSet"
        :columns="columnas"
        row-key="uuid"
        v-model:pagination="paginadoGenericoStore.filtros"
        :loading="loading"
        @request="onPaginar"
      >
        <!--------------------------------------
            loading
          ---------------------------------------->
        <template v-slot:loading>
          <Loading showing />
        </template>

        <template v-slot:top-left>
          <div class="q-col-gutter-md row">
            <q-input
              dense
              placeholder="Buscar ..."
              v-model="paginadoGenericoStore.filtros.query"
              debounce="300"
            >
              <template v-slot:append>
                <q-icon name="search" />
              </template>
            </q-input>

            <q-btn color="green" flat label="Filtrar" @click="onRequest" />
            <q-btn color="blue" flat label="Reset" @click="onResetFiltros" />
          </div>
        </template>

        <template v-slot:body-cell-opciones="props">
          <q-td :props="props">
            <q-btn
              flat
              color="green"
              size="sm"
              icon="pin_drop"
              :to="'/administrador/novedades/editar/' + props.row.uuid"
            >
              Editar
            </q-btn>

            <q-btn
              flat
              color="green"
              size="sm"
              icon="pin_drop"
              @click="borrarNovedad(props.row.uuid)"
            >
              Borrar
            </q-btn>
          </q-td>
        </template>

        <template v-slot:body-cell-mensaje="props">
          <q-td :props="props">
            {{ props.row.detalle }}
            <hr />
            link : {{ props.row.link }}
          </q-td>
        </template>
      </q-table>
    </q-card>
  </q-page>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref } from 'vue';
import { QTableProps } from 'quasar';
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
import { usePaginadoGenericoStore } from 'src/stores/paginado-generico';
import Loading from 'src/components/Loading.vue';
// Defino las columnas de la tabla
const columnas: QTableProps['columns'] = [
  { name: 'mensaje', label: 'mensaje', field: 'mensaje', align: 'left' },
  { name: 'datos', label: 'datos', field: 'datos', align: 'left' },
  { name: 'opciones', label: 'Opciones', field: 'opciones', align: 'left' },
];

export default defineComponent({
  components: { Loading },
  name: 'ListadoPage',
  setup() {
    const loading = ref(true);
    const paginadoGenericoStore = usePaginadoGenericoStore();

    onMounted(() => {
      onRequest();
    });

    ////////////////////////////////////////////////////////////////////////////////
    //            GESTION DE PAGINADO Y GESTION DE DATOS
    ////////////////////////////////////////////////////////////////////////////////
    /*********************************************
     *  Metodo onPaginar
     *  Gestiona la configuracion del paginado.
     */
    function onPaginar(props: QTableProps) {
      paginadoGenericoStore.setPaginar(props);
      onRequest();
    }

    function onFiltrar() {
      paginadoGenericoStore.filtroActivado = true;
      paginadoGenericoStore.filtros.page = 1; // siempre que vuelvo a filtra, vuelvo a la pagina 1.
      onRequest();
    }

    /*********************************************
     *  Metoto onRequest
     *  encargado de obtener los datos desde la API
     */
    const dataSet = ref([]);
    function onRequest() {
      loading.value = true;
      api
        .get('/api/administrador/novedades', {
          params: paginadoGenericoStore.parametros,
        })
        .then((response: AxiosResponse) => {
          paginadoGenericoStore.setRowTotal(response.data.count); // Actializo la cantidas de row, por si cambio
          dataSet.value = response.data.data;
          loading.value = false;
        })
        .finally(() => {
          loading.value = false;
        });
    }

    /*********************************************
     *  Metoto resetFiltros
     *  Reinilizo los Filtros
     */
    function onResetFiltros() {
      paginadoGenericoStore.resetFiltros();
      // getCombosEquipos();
      // Recargo la info de la pagina !
      onRequest();
    }

    function borrarNovedad(novedadUuid: string) {
      loading.value = true;
      api
        .delete('/api/administrador/novedades', {
          data: { uuid: novedadUuid },
        })
        .then(() => {
          onRequest();
        })
        .finally(() => {
          loading.value = false;
        });
    }

    return {
      columnas,
      dataSet,
      paginadoGenericoStore,
      onRequest,
      onPaginar,
      onResetFiltros,
      onFiltrar,
      loading,
      borrarNovedad,
    };
  },
});
</script>
